

#ifndef _DWM_DEBUG_H
#define _DWM_DEBUG_H

#include <stdio.h>
#include "dwm-object.h"

class DWMDebug : public DWMObject {
 public:
  DWMDebug() { my_value = 0; }
  DWMDebug(int initial_value) { my_value = initial_value; }
  DWMDebug(char *name, int initial_value = 0) : DWMObject(name) 
    { my_value = initial_value; }

  virtual DWMClassType Class_Type() const { return DWMDebugClass; }
  virtual char *Class_Name() const { return "DWMDebugClass"; }

  int Get_Value() const { return my_value; }
  void Set_Value(int new_value) { my_value = new_value; }

  virtual void Print_Diagnostics() const {
    printf("DWMDebug object: name = %s, value = %d\n",
	   name, my_value);
  };

 private:
  int my_value;

};

extern DWMDebug DWMNoObject;


#endif


