//
// dwm-flick.h
//
// This file provides the class definition for the DWMFlickList class object.
// This object is designed to store objects derived from the 
// DWMObject class as a linked list, and iterate through them very quickly. 
// In addition to the DWMList functionality, this structure supports
// the functions:
//
//     DWMObject *Flick();
//     void       FReset();
//
// which will return the next object in the list (or DWMNoObject if it is at
// the end of the list), and reset the internal 
// pointer to the beginning of the list respectively.
//
// George Patterson,  Aug 17 1994
//

#ifndef _DWM_FLICK_H
#define _DWM_FLICK_H

#include "dwm-list.h"

class DWMFlickList : public DWMList {
  
 public:
  DWMFlickList() : DWMList() { flick = head; }
  DWMFlickList(char *list_name) : DWMList(list_name) 
    { flick = head; }

  ~DWMFlickList() {};

  /*** here are the new user functions added by FlickList.... ***/

  DWMObject *Flick();
  void FReset() { flick = head; }

 protected:
  ListElement *flick;

};

#endif
