%{
/*
 * here are my comments.
 */
#include <stdlib.h>
#include <string.h>
#include "y.tab.h"

%}

%%

[\t ]+   /* dont do anything here*/; 

[Cc]omment { return(COMMENT); }

Set|set { return(SET); }

load|Load { return(LOAD); }

loadstate|Loadstate { return(LOAD_STATE); }

loadfield|Loadfield { return(LOAD_FIELD); }

loadasciifield|Loadasciifield { return(LOAD_ASCII_FIELD); }

Exit|exit|Quit|quit { return(QUIT); }

create|Create { return(CREATE); }

bubble { return(BUBBLE); }

tsequence|tseq { return(TSEQUENCE); }

groove { return(GROOVE); }

delete|del|Delete { return(DELETE); }

run|Run { return(RUN); }

reset|res|Reset|Res { return(RESET); }

print|pr|Print { return(PRINT); }

mlopta { return(ML_OPTIMIZE_A); }

cgroove { return(C_GROOVE); }

Ms|ms { strcpy(yylval.cval, "ms"); return(MS); }

Clength|clength { strcpy(yylval.cval, "clength"); return(CLENGTH); }

Alpha|alpha { strcpy(yylval.cval, "alpha"); return(ALPHA); }

Q|Quality|quality { strcpy(yylval.cval, "q"); return(QUALITY); }

Mobility|
mobility|mob { strcpy(yylval.cval, "mobility"); return(MOBILITY); }

Maximum_Velocity |
Max_Velocity |
Max_velocity |
max_velocity { strcpy(yylval.cval, "maximum_velocity"); return(MAX_VELOCITY); }

Material_Thickness|material_thickness|
Thickness|thickness { strcpy(yylval.cval, "thickness"); return(MATERIAL_THICKNESS); }

Time_Step |
time_step |
TStep |
Tstep |
tstep { strcpy(yylval.cval, "time_step"); return(TIME_STEP); }

Time_Save|TSave|
Tsave|tsave { strcpy(yylval.cval, "time_save"); return(TIME_SAVE); }

Bias|bias { strcpy(yylval.cval, "bias"); return(BIAS); }

Coervivity|coercivity { strcpy(yylval.cval, "coercivity"); return(COERCIVITY); }

output|outname { strcpy(yylval.cval, "output_name"); return(OUTPUT_NAME); }

debug { strcpy(yylval.cval, "debug"); return(DEBUG_STATUS); }

nm|nanometers  { return(NANOMETERS); }
mm|millimeters { return(MILLIMETERS); }
cm|centimeters { return(CENTIMETERS); }
m|meters       { return(METERS); }

xpos    { strcpy(yylval.cval, "xposition"); return XPOSITION; }
ypos    { strcpy(yylval.cval, "yposition"); return YPOSITION; }
radius  { strcpy(yylval.cval, "radius");    return RADIUS;    }
npoints { strcpy(yylval.cval, "npoints");   return NPOINTS;   }
file    { strcpy(yylval.cval, "file");      return SOURCE_FILE;  }

xsize   { strcpy(yylval.cval, yytext);return XSIZE; }
ysize   { strcpy(yylval.cval, yytext);return YSIZE; }
xoffset { strcpy(yylval.cval, yytext);return XOFFSET; }
yoffset { strcpy(yylval.cval, yytext);return YOFFSET; }
xorigin { strcpy(yylval.cval, yytext);return XORIGIN; }
yorigin { strcpy(yylval.cval, yytext);return YORIGIN; }
dx      { strcpy(yylval.cval, yytext);return DX; }
dy      { strcpy(yylval.cval, yytext);return DY; }
xborder { strcpy(yylval.cval, yytext);return XBORDER; }
yborder { strcpy(yylval.cval, yytext);return YBORDER; }
rotation   { strcpy(yylval.cval, yytext);return ROTATION; }

rise_time|rt     { strcpy(yylval.cval, yytext); return RISE_TIME;     }
fall_time|ft     { strcpy(yylval.cval, yytext); return FALL_TIME;     }
pulse_width|width|pw   { strcpy(yylval.cval, yytext); return PULSE_WIDTH;   }
pulse_cycle|cycle|pc   { strcpy(yylval.cval, yytext); return PULSE_CYCLE;   }
pulse_offset|offset|po  { strcpy(yylval.cval, yytext); return PULSE_OFFSET;  }
bias_current|bc  { strcpy(yylval.cval, yytext); return BIAS_CURRENT;  }
pulse_current|pc { strcpy(yylval.cval, yytext); return PULSE_CURRENT; }

writefield  { strcpy(yylval.cval, yytext); return WRITE_FIELD;     }

write  { strcpy(yylval.cval, yytext); return WRITE;     }

[a-zA-Z][0-9a-zA-Z\.\-]+ { strcpy(yylval.cval, yytext); return(STRING); }

(-)?(([0-9]+)|([0-9]*\.[0-9]*))([eE][+-]?[0-9]+)? 
  { yylval.dval = atof(yytext); return(NUMBER); }

#.* /* ignore comments */;

\; |
\n |
(\;\n) { return 0; }

%%
