//
// dwm-object.h
// 
// Ramdom additional C++ code to support the DWMObject base class.
//

#include "dwm-object.h"

// Here I define the equality (==) and inequality (!=) operators 
// as they act on DWMObjects.  I am strict in requiring that two objects
// physically occupy the same space in memory to be equal 
// (that is a == a, and a does not == a copy of a).
// In a more flexible system (or maybe later), I might define some
// equality operations to see if two objects are copies of one another.
// 
// George Patterson, Aug 16 1994.

int operator== (DWMObject &item1, DWMObject &item2) 
{
  return( &item1 == &item2 ); // compare the addresses
}

int operator!= (DWMObject &item1, DWMObject &item2) 
{
  return( &item1 != &item2 ); // compare the addresses
}

// mixed argument type versions of the same function....

int operator== (DWMObject *item1, DWMObject &item2) 
{  return( item1 == &item2 ); }

int operator!= (DWMObject *item1, DWMObject &item2) 
{  return( item1 != &item2 ); }

// .....another mixed type case....

int operator== (DWMObject &item1, DWMObject *item2) 
{  return( &item1 == item2 ); }

int operator!= (DWMObject &item1, DWMObject *item2) 
{  return( &item1 != item2 ); }


