//
// dwm-tfield.h
//
// This header file provides the definition for the DWMTField object.
// This object basically consists of the DWMField abstract object, plus some
// associated machinery to hold a list of DWMTimingObject s.
// This is an abstract object that serves as the base class for all present
// and future field type objects.
//
// 8/24/94 started

#ifndef _DWM_TFIELD_H
#define _DWM_TFIELD_H

typedef double DWMfloat;

#include "dwm-field.h"
#include "dwm-flick.h"

class DWMTField : public DWMField {

 public:
  DWMTField() { tsequence_list = new DWMFlickList; }
  DWMTField( char *name ) : DWMField(name) { tsequence_list = new DWMFlickList; }
  ~DWMTField() { tsequence_list->Flush(); delete tsequence_list; }

  void Add_TimingObject( DWMObject &toadd ) { tsequence_list->Add( toadd ); }
  void Flush() { tsequence_list->Flush(); }

  DWMObject *Contains_Named_Object( char *name) const 
    { return tsequence_list->Contains_Named_Object(name); }

  DWMfloat TScale( DWMfloat time ) const;
  void Print_Timing_Objects() const;
    
  private:

    DWMFlickList *tsequence_list;

};

#endif

