#include <stdio.h>

#include "dwm-timing-obj.h"

typedef double DWMfloat;


DWMfloat DWMTimingObject::TScale(DWMfloat time) const
{

  DWMfloat new_time = time - pulse_offset;

  if( cycle_time != 0.0 ) {
    int idivisor = (int)(new_time / cycle_time);
    new_time = new_time - ((DWMfloat) idivisor) * cycle_time;
  }

  if( new_time <= t1 ) 
    return bias_current;

  if( new_time > t1 && new_time  < t2 )
    return( bias_current + rise_time_slope * (new_time - t1) * pulse_current );

  if( new_time >= t2 && new_time <= t3 ) 
    return (bias_current + pulse_current);

  if( new_time > t3 && new_time < t4)
    return( bias_current + (1.0 - rise_time_slope * (new_time - t3)) * pulse_current );

  return bias_current;

}


void DWMTimingObject::Print_Diagnostics() const
{
  printf("DWMTimingClass Object:\n");
  printf("\tName           = %s\n", Name());
  printf("\tBias Current   = %f\n", bias_current);
  printf("\tPulse Current  = %f\n", pulse_current);
  printf("\tRise_Time      = %f\n", rise_time);
  printf("\tFall_Time      = %f\n", fall_time);
  printf("\tPulse Width    = %f\n", pulse_width);  
  printf("\tPulse Offset   = %f\n", pulse_offset);
  printf("\tCycle Time     = %f\n", cycle_time);
  printf("\n");
}

