%{
/*
 *
 *
 */

#include<stdio.h>
#include<stdlib.h>
#include"dwm-v1.h"
#include"dwm-object.h"
#include"dwm-flick.h"
#include"dwm-debug.h"
#include"dwm-keyword.h"

extern DWMFlickList *keyword_list;

%}

%union {
  double dval;
  char cval[64];
}

%token <cval> COMMENT
%token <cval> SET
%token <cval> STRING 
%token <dval> NUMBER
%token <cval> QUIT
%token <cval> ML_OPTIMIZE_A
%token <cval> C_GROOVE
%type <cval> c_groove_sentence

%token <cval> MS CLENGTH QUALITY ALPHA MOBILITY MAX_VELOCITY
%token <cval> MATERIAL_THICKNESS TIME_STEP TIME_SAVE
%token <cval> BIAS COERCIVITY OUTPUT_NAME DEBUG_STATUS 

/* tokens assoaicted with physical units...*/
%token <cval> NANOMETERS  MICROMETERS  MILLIMETERS  CENTIMETERS METERS
%token <cval> ANGSTROMS
%token <cval> NANOSECONDS MICROSECONDS MILLISECONDS SECONDS
%token <cval> OERSTED GAUSS TESLA

/* ............ */
%token <cval> LOAD
%token <cval> LOAD_STATE

/* ...tokens asociated with the loadfield and loadasciifield operation..... */
%token <cval> LOAD_FIELD
%token <cval> LOAD_ASCII_FIELD
%token <cval> XSIZE YSIZE XOFFSET YOFFSET XORIGIN YORIGIN DX DY
%token <cval> ROTATION


/* Tokens associated with the create operation.... */
%token <cval> CREATE BUBBLE STRIPE TSEQUENCE GROOVE
%token <cval> XPOSITION YPOSITION RADIUS NPOINTS
%token <cval> SOURCE_FILE
%token <cval> RISE_TIME FALL_TIME PULSE_WIDTH PULSE_CYCLE PULSE_OFFSET
%token <cval> BIAS_CURRENT PULSE_CURRENT
%token <cval> XBORDER YBORDER

%token <cval> DELETE
%token <cval> RUN
%token <cval> RESET
%token <cval> PRINT

%token <cval> WRITE_FIELD
%token <cval> WRITE

/* non-terminals involved in the load keyword... */
%type <cval> load_sentence
%type <cval> load_state_sentence

/* non-terminals involved with the loadfield and loadasciifield keyword...*/
%type <cval> load_field_sentence
%type <cval> load_ascii_field_sentence
%type <cval> load_field_option_list
%type <cval> load_field_option
%type <cval> load_field_option_keyword

/* ...non-terminals involved with the create keyword....*/
%type <cval> create_sentence
%type <cval> create_bubble_sentence
/* %type <cval> create_stripe_sentence */
%type <cval> create_tsequence_sentence

%type <cval> create_bubble_option_list
%type <cval> create_bubble_option
%type <cval> create_bubble_option_keyword

%type <cval> create_groove_sentence
%type <cval> create_groove_option_list
%type <cval> create_groove_option
%type <cval> create_groove_option_keyword

/***
%type <cval> create_stripe_option_list
%type <cval> create_stripe_option
%type <cval> create_stripe_keyword
***/

%type <cval> create_tsequence_option_list
%type <cval> create_tsequence_option
%type <cval> create_tsequence_option_keyword

/* ... non-terminals involved with the simple instance of the set keyword...*/
%type <cval> simple_set_sentence
%type <cval> material_parameter
%type <cval> distance_unit
%type <dval> u_number
%type <cval> valid_sentence

%type <cval> delete_sentence
%type <cval> run_sentence
%type <cval> reset_sentence
%type <cval> print_sentence
%type <cval> quit_sentence
%type <cval> string_of_strings
%type <cval> comment_sentence
%type <cval> void_sentence
%type <cval> ml_optimize_a_sentence
%type <cval> write_field_sentence
%type <cval> write_object_sentence

%%

/* OK -- here we go with the patterns and actions */

valid_sentence: load_sentence |
	load_state_sentence |
	load_field_sentence |
	load_ascii_field_sentence |
	simple_set_sentence |
	create_sentence |
	delete_sentence |
	run_sentence |
	reset_sentence |
	print_sentence |
	quit_sentence |
	comment_sentence |
	void_sentence |
        ml_optimize_a_sentence |
        c_groove_sentence |
        write_field_sentence |
        write_object_sentence
	;

load_sentence: LOAD STRING
	{ process_load_sentence($2); }
	;

load_state_sentence: LOAD_STATE STRING
	{ process_load_state_sentence($2); }
	;

load_field_sentence: LOAD_FIELD STRING STRING load_field_option_list
	{ process_load_field_sentence($2, $3, keyword_list); }
	;

load_ascii_field_sentence: LOAD_ASCII_FIELD STRING STRING load_field_option_list
	{ process_load_ascii_field_sentence($2, $3, keyword_list); }
	;

load_field_option_list: /*  */ { strcpy($$,"foo"); } |
	load_field_option_list load_field_option
	;

load_field_option: load_field_option_keyword NUMBER
	{ 
	/* Save the keyword away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename($1);
	foo->Set_Value($2);
	keyword_list->Add(*foo);
	}
	;

load_field_option_keyword: XSIZE | 
  YSIZE |
  XOFFSET |
  YOFFSET |
  XORIGIN |
  YORIGIN |
  DX |
  DY
  ;

/****
  Now we begin with "create" sentences
 ***/

create_sentence: create_bubble_sentence |
	create_tsequence_sentence |
	create_groove_sentence
	;

create_bubble_sentence: CREATE BUBBLE create_bubble_option_list
	{ process_create_bubble_sentence(0, keyword_list); } |
        CREATE BUBBLE STRING create_bubble_option_list
	{ process_create_bubble_sentence($3, keyword_list); }
	;

create_bubble_option_list: /* empty */ {strcpy($$,"foo argument"); } |
	create_bubble_option_list create_bubble_option
	;

create_bubble_option: create_bubble_option_keyword NUMBER
	{ 
	/* Save the keyword away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename($1);
	foo->Set_Value($2);
	keyword_list->Add(*foo);
	} |
        create_bubble_option_keyword STRING
	{ 
	/* Save the keyword away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename($1);
	foo->Set_Value($2);
	keyword_list->Add(*foo);
	}
	;

create_bubble_option_keyword: XPOSITION |
	YPOSITION |
	RADIUS |
	NPOINTS |
        SOURCE_FILE
	;

create_tsequence_sentence: CREATE TSEQUENCE STRING STRING create_tsequence_option_list
	{ process_create_tsequence_sentence($3, $4, keyword_list); }
	;

create_tsequence_option_list: /* empty */ { strcpy($$,"foo argument"); } |
	create_tsequence_option_list create_tsequence_option
	;

create_tsequence_option: create_tsequence_option_keyword NUMBER
	{ 
	/* Save the keyword away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename($1);
	foo->Set_Value($2);
	keyword_list->Add(*foo);
	}
	;

create_tsequence_option_keyword: RISE_TIME |
	FALL_TIME |
	PULSE_WIDTH |
	PULSE_CYCLE |
	PULSE_OFFSET |
	BIAS_CURRENT |
	PULSE_CURRENT
	;

create_groove_sentence: 
	CREATE GROOVE NUMBER NUMBER NUMBER NUMBER NUMBER create_groove_option_list
	{ process_create_groove_sentence("foo", $3, $4, $5, $6, $7,keyword_list); } |
        CREATE GROOVE STRING NUMBER NUMBER NUMBER NUMBER NUMBER create_groove_option_list
	{ process_create_groove_sentence($3, $4, $5, $6, $7, $8, keyword_list); }
	;

create_groove_option_list: /* empty */ {strcpy($$,"foo argument"); } |
	create_groove_option_list create_groove_option
	;

create_groove_option: create_groove_option_keyword NUMBER
	{ 
	/* Save the keyword away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename($1);
	foo->Set_Value($2);
	keyword_list->Add(*foo);
	}
	;

create_groove_option_keyword: DX |
	DY |
        XBORDER |
        YBORDER |
        ROTATION
	;

simple_set_sentence: SET material_parameter u_number
  { process_simple_set_sentence($2, $3); } |
  SET material_parameter STRING
  { process_simple_set_sentence($2, $3); }
  ;

material_parameter: MS | 
     CLENGTH |
     ALPHA |
     QUALITY |
     MOBILITY | 
     MAX_VELOCITY |
     MATERIAL_THICKNESS |
     TIME_STEP |
     TIME_SAVE |
     BIAS |
     COERCIVITY |
     OUTPUT_NAME |
     DEBUG_STATUS
     ;

distance_unit:  ANGSTROMS | 
    NANOMETERS | 
    MILLIMETERS |
    CENTIMETERS |
    METERS 
    ;

u_number: NUMBER { $$ = $1; } | 
  NUMBER distance_unit { $$ = $1; }
  ;     

delete_sentence: DELETE STRING { process_delete_sentence($2, NULL); } |
	DELETE STRING STRING { process_delete_sentence($2, $3); }
	;

run_sentence: RUN  { process_run_sentence(); } |
	RUN NUMBER { process_run_sentence($2); }
	;

reset_sentence: RESET
	{ process_reset_sentence(); }
	;

print_sentence: PRINT
        { process_print_sentence( 0, 0 ); } |
        PRINT STRING
	{ process_print_sentence($2, 0); } |
        PRINT STRING STRING
        { process_print_sentence($2, $3); }
	;

quit_sentence: QUIT
	{ process_quit_sentence(); }
        ;

void_sentence: /*  */
        { strcpy($$,""); }
        ;

comment_sentence: COMMENT { process_comment_sentence(keyword_list); } | 
        COMMENT string_of_strings { process_comment_sentence(keyword_list); }
        ;

ml_optimize_a_sentence: ML_OPTIMIZE_A NUMBER NUMBER NUMBER NUMBER NUMBER
        { ml_optimize( $2, $3, $4, $5, $6); } 
        ;

c_groove_sentence: C_GROOVE { groove_characterization(); } ;

string_of_strings:
        string_of_strings STRING |
        STRING 	{ 
	/* Save the string away on the keyword_list */
	DWMKeyword *foo = new DWMKeyword;
	foo->Rename("comment");
	foo->Set_Value($1);
	keyword_list->Add(*foo);
	}
        ;

write_field_sentence:
       WRITE_FIELD STRING NUMBER NUMBER NUMBER NUMBER NUMBER NUMBER
       { process_write_field_sentence($2, $3, $4, $5, $6, $7, $8); };

write_object_sentence:
       WRITE STRING STRING
       { process_write_object_sentence($2, $3); };

%%

yyerror(char *s)
{
  printf("Error: %s\n",s);
}

