class Vector{
      public:

	/* first the constructors and destructors */

	Vector() {dimensions=0; representation=0;}
	Vector(unsigned dimensions);
	Vector(const Vector&);
	~Vector() { if(dimensions!=0) delete [] components;}
	Vector& operator=(const Vector& );


	/* here are all of the friends that have access to the data */

	friend Vector operator+(const Vector&, const Vector&);
	friend Vector operator-(const Vector&, const Vector&);
	friend double DotProduct(const Vector&, const Vector&);
	friend Vector CrossProduct(const Vector&, const Vector&);
	// friend double operator()(unsigned); -- this would be nice...


	/* and finally the public calls */

	void Stats();
	void Print();
	void Normalize();
	void Scale(double);
	double Magnitude();
	void Set_Component(int, double);
	double Get_Component(int) const;
	unsigned Dimensions() { return dimensions; }
	void Set_Representation(unsigned new_rep) { representation = new_rep; }
	unsigned Get_Representation() { return representation; }
	void Scale_Component(int, double);

	/* The following are nice when rectangular components are used. */

	double x() { assert(dimensions>=1 && representation==0); 
		     return(*(components));}
	double y() { assert(dimensions>=2 && representation==0); 
		     return(*(components+1));}
	double z() { assert(dimensions>=3 && representation==0); 
		     return(*(components+2));}


      protected:

	/* if dimensions == 0, then components has not been allocated */
	unsigned dimensions;
	unsigned representation;
	double *components;
};
