/*
   header file for the wall point class definition...

*/


class WallPoint {
      public:

	/* first the constructors and destructors */
	WallPoint() { previous = 0; next = 0; initialize_vectors(); }
	WallPoint(Vector new_position, double angle)
	  { position = new_position; Phia = angle;
	    previous = 0; next = 0; 
	    initialize_vectors(); }
	//WallPoint(WallPoint *wp1, WallPoint *wp2) {}
	~WallPoint() {};


	/* now the procedures that operate on the data */

	void Update_Fields();
	void Update_Internals();
	void Calculate_Forces();
	void Calculate_Delta_Phia();
	void Update_Wall();
	void Update_Position();

	void Set_Position(Vector new_position);
	void Set_Position(Vector new_position, double angle); 
	Vector& Position() { return position; }
	void Print_Diagnostics(); 

	WallPoint *previous, *next;

	double dS_dt;
	double normalized_distance;
	double delta_s_previous;
	double delta_s_next;
	double curvature_1;

	double d_1_plus, d_1_0, d_1_minus;
	double d_2_plus, d_2_0, d_2_minus;

	Vector WallTangent;
	Vector WallNormal;
	Vector Hdemag;
	double Phia;
	double Phiw;
	double Phin;
	Vector delta_RSPhi;
	Vector Hexternal;
	Vector WallForce;

	double force_r_1, force_r_2, force_r_3;

      private:

	void initialize_vectors();
	
	Vector position;

};
